﻿using System.Windows.Forms;
using Styx;
using Styx.Combat.CombatRoutine;
using Styx.Helpers;

namespace The_Combobox
{
    public class ClassYouCanChoose : CombatRoutine
    {
        private Form _configForm;

        /// <summary>
        /// The name of this CombatRoutine
        /// </summary>
        /// <value>
        /// The name.
        /// </value>
        public override string Name
        {
            get { return "The Combobox Show Off"; }
        }

        /// <summary>
        /// The <see cref="T:Styx.Combat.CombatRoutine.WoWClass"/> to be used with this routine
        /// </summary>
        /// <value>
        /// The class.
        /// </value>
        public override WoWClass Class
        {
            get { return StyxWoW.Me.Class; }
        }

        /// <summary>
        /// Whether this CC want the button on the form to be enabled.
        /// </summary>
        public override bool WantButton
        {
            get { return true; }
        }

        /// <summary>
        /// Called when the button for this CC is pressed.
        /// </summary>
        public override void OnButtonPress()
        {
            if (_configForm == null || _configForm.IsDisposed || _configForm.Disposing)
                _configForm = new TheComboboxShowOff();
            _configForm.ShowDialog();
        }

        /// <summary>
        /// Called when this CC is selected as the current CC.
        /// </summary>
        public override void Initialize()
        {
            GeneralSettings.Instance.Load();
        }

        /// <summary>
        /// Combat actions.
        /// </summary>
        public override void Combat()
        {
            Logging.Write(string.Format("Your chosen settings are: {0}", GeneralSettings.Instance.The_Ugly));
        }
    }
}